<?php
//**********************************************************
// fonction test si format date francaise est ok
// date_fr : date au format francais JJ/MM/AAAA
//**********************************************************

function test_date_fr ($date_fr) {
   $erreur_format_date = 1 ;
// test si il y a 2 barres de slash
  $nb_slash = substr_count($date_fr, '/');
  if ( $nb_slash == 2) {
    $date_explosee = explode("/", $date_fr);
    $jour_fr = $date_explosee[0];
    $mois_fr = $date_explosee[1];
    $an_fr = $date_explosee[2];
    if ( is_numeric($jour_fr) && is_numeric($mois_fr) && is_numeric($an_fr) ) {
      if ( $jour_fr > 0 && $jour_fr < 32 && $mois_fr > 0 && $mois_fr < 13 && $an_fr > 2000 && $an_fr < 2030 ) {
        $erreur_format_date = 0 ;
      }
    }
  }
  return ($erreur_format_date);
}
//**********************************************************

//**********************************************************
// fonction test si format date francaise est ok
// date_eng : date au format anglais AAAA/MM/JJ
//**********************************************************

function test_date_eng ($date_eng) {
   $erreur_format_date = 1 ;
// test si il y a 2 tirets
  $nb_tiret = substr_count($date_eng, '-');
  if ( $nb_tiret == 2) {
    $date_explosee = explode("-", $date_eng);
    $jour_eng = $date_explosee[2];
    $mois_eng = $date_explosee[1];
    $an_eng = $date_explosee[0];
    if ( is_numeric($jour_eng) && is_numeric($mois_eng) && is_numeric($an_eng) ) {
      if ( $jour_eng > 0 && $jour_eng < 32 && $mois_eng > 0 && $mois_eng < 13 && $an_eng > 2000 && $an_eng < 2030 ) {
        $erreur_format_date = 0 ;
      }
    }
  }
  return ($erreur_format_date);
}
//**********************************************************

//**********************************************************************
// conversion format de date francais vers anglais
// $date_fr           : date au format francais JJ MM AAAA
// $separateur_source      : texte sparateur de champs de la date francaise
// $separateur_destination : texte sparateur de champs date de sortie
//**********************************************************************

function date_fr_eng ($date_fr,$separateur_source,$separateur_destination) {
  list($jour_fr,$mois_fr,$an_fr) = explode($separateur_source, $date_fr);
  $date_eng = $an_fr.$separateur_destination.$mois_fr.$separateur_destination.$jour_fr;
  return ($date_eng);
  }
//**********************************************************************

//**********************************************************************
// conversion format de date anglais vers francais
// $date_eng           : date au format francais AAAA MM JJ
// $separateur_source      : texte sparateur de champs de la date francaise
// $separateur_destination : texte sparateur de champs date de sortie
//**********************************************************************

function date_eng_fr ($date_eng,$separateur_source,$separateur_destination) {
  list($an_eng,$mois_eng,$jour_eng) = explode($separateur_source, $date_eng);
  $date_fr = $jour_eng.$separateur_destination.$mois_eng.$separateur_destination.$an_eng;
  return ($date_fr);
  }
//**********************************************************************

//**********************************************************************
// retourne le jour precedent de la date d'entre au meme format
// $date       : date par rapport a laquelle le jour precedent sera calule
// $separateur      : texte sparateur de champs de la date
// $langue          : format de la langue eng ou fr
//**********************************************************************

function jour_precedent ($date,$separateur,$langue) {
  if ( $langue == "eng") {
  list($an,$mois,$jour) = explode($separateur, $date);

  $jour = $jour - 1;
  if ( $jour <= 0) {
      $mois = $mois - 1;
      if ( $mois <= 0 ) {
           $mois = 12;
           $an = $an - 1;
           }
      $jour = strftime("%d",mktime ( 6,0,0,$mois+1 ,0,$an)) ;
  }
  $date_jour_precedent  = $an.$separateur.$mois.$separateur.$jour;
  }
  else {
  list($jour,$mois,$an) = explode($separateur, $date);

  $jour = $jour - 1;

  if ( $jour <= 0) {
      $mois = $mois - 1 ;
      if ( $mois <= 0 ) {
           $mois = 12;
           $an = $an - 1;
           }
      $jour = strftime("%d",mktime ( 6,0,0,$mois+1,0,$an)) ;
  }
  $date_jour_precedent  = $jour.$separateur.$mois.$separateur.$an;
  }

  return ($date_jour_precedent);
  }
//**********************************************************************

//**********************************************************************
//fonction ajout de \ devant les guillemets pour eciture dans fichier
//**********************************************************************

function guillet_var ($texte) {
  $texte_guillemet = str_replace('\\','',$texte);
  $texte_guillemet = str_replace('"','\"',$texte_guillemet) ;
  return ($texte_guillemet);
  }
//**********************************************************************

//**********************************************************************
//fonction ajout de \ devant les apostrophes pour eciture dans fichier
//**********************************************************************

function apos_var ($texte) {
  $texte_guillemet = str_replace('\\','',$texte);
  $texte_guillemet = str_replace("'","\'",$texte_guillemet) ;
  return ($texte_guillemet);
  }
//**********************************************************************

//**********************************************************************
// En fonction du jour de debut de semaine paramtr, retourne l'index
// du numro de jour de la semaine pour le premier jour du mois
//**********************************************************************

function jour_debut_semaine ($jour,$mois ,$annee) {
  $premier_jour_mois = date("w",mktime ( 6,0,0,$mois ,1,$annee)) ;
  switch ($jour) {
    case "lundi":
    if ( $premier_jour_mois == 0)
       $premier_jour_mois = 7;
    break;
    case "mardi":
     $premier_jour_mois = $premier_jour_mois + 6;
     if ( $premier_jour_mois > 7)
     $premier_jour_mois = $premier_jour_mois - 7;
    break;
    case "mercredi":
     $premier_jour_mois = $premier_jour_mois + 5;
     if ( $premier_jour_mois > 7)
     $premier_jour_mois = $premier_jour_mois - 7 ;
    break;
    case "jeudi":
     $premier_jour_mois = $premier_jour_mois + 4;
     if ( $premier_jour_mois > 7)
     $premier_jour_mois = $premier_jour_mois - 7 ;
    break;
    case "vendredi":
     $premier_jour_mois = $premier_jour_mois + 3;
     if ( $premier_jour_mois > 7)
     $premier_jour_mois = $premier_jour_mois - 7 ;
    break;
    case "samedi":
     $premier_jour_mois = $premier_jour_mois + 2;
     if ( $premier_jour_mois > 7)
     $premier_jour_mois = $premier_jour_mois - 7 ;
    break;
    case "dimanche":
     $premier_jour_mois  = $premier_jour_mois + 1;
     if ( $premier_jour_mois > 7)
     $premier_jour_mois = $premier_jour_mois - 7 ;
    break;
    }
  return ($premier_jour_mois);
  }
//**********************************************************************

//**********************************************************************
// retourne le nouvel index de numero jour de semaine en fonction
// du paramtrage du jour de debut de semaine voulu
//**********************************************************************

function correction_debut_semaine ($jour,$cle) {
  global $index_jour_lundi;
  global $index_jour_samedi;
  global $index_jour_dimanche;
  $nouvelle_cle = $cle ;
  switch ($jour) {
    case "lundi":
      $nouvelle_cle = $cle ;
    break;
    case "mardi":
      if ( $cle < 8)
      $nouvelle_cle = $cle + 1;
      if ( $nouvelle_cle >= 7)
         $nouvelle_cle = $nouvelle_cle - 7;
      if ( $cle > 7)
      $nouvelle_cle = $cle ;
    break;
    case "mercredi":
      if ( $cle < 8)
      $nouvelle_cle = $cle + 2;
      if ( $nouvelle_cle >= 7)
         $nouvelle_cle = $nouvelle_cle - 7;
      if ( $cle > 7)
      $nouvelle_cle = $cle ;
    break;
    case "jeudi":
      if ( $cle < 8)
      $nouvelle_cle = $cle + 3;
      if ( $nouvelle_cle >= 7)
         $nouvelle_cle = $nouvelle_cle - 7;
      if ( $cle > 7)
      $nouvelle_cle = $cle ;
    break;
    case "vendredi":
      if ( $cle < 8)
      $nouvelle_cle = $cle + 4;
      if ( $nouvelle_cle >= 7)
         $nouvelle_cle = $nouvelle_cle - 7;
      if ( $cle > 7)
      $nouvelle_cle = $cle ;
    break;
    case "samedi":
      if ( $cle < 8)
      $nouvelle_cle = $cle + 5;
      if ( $nouvelle_cle >= 7)
         $nouvelle_cle = $nouvelle_cle - 7;
      if ( $cle > 7)
      $nouvelle_cle = $cle ;
    break;
    case "dimanche":
      if ( $cle < 8)
      $nouvelle_cle = $cle + 6;
      if ( $nouvelle_cle >= 7)
         $nouvelle_cle = $nouvelle_cle - 7;
      if ( $cle > 7)
      $nouvelle_cle = $cle ;
    break;
    }
  //recherche index du lundi 
  if ( $nouvelle_cle == 1 )
      $index_jour_lundi = $cle;  
    //recherche index du samedi
  if ( $nouvelle_cle == 6 )
      $index_jour_samedi = $cle;
    //recherche index du dimanche
  if ( $nouvelle_cle == 0 || $nouvelle_cle == 7)
      $index_jour_dimanche = $cle;
  return ($nouvelle_cle);
  }
//**********************************************************************

//*******************************************************************************************
// cryptage d'une chaine de caractre en fonction d'une cl
//*******************************************************************************************

function GenerationCle($Texte,$CleDEncryptage)
  {
  $CleDEncryptage = md5($CleDEncryptage);
  $Compteur=0;
  $VariableTemp = "";
  for ($Ctr=0;$Ctr<strlen($Texte);$Ctr++)
    {
    if ($Compteur==strlen($CleDEncryptage))
      $Compteur=0;
    $VariableTemp.= substr($Texte,$Ctr,1) ^ substr($CleDEncryptage,$Compteur,1);
    $Compteur++;
    }
  return $VariableTemp;
  }

function Crypte($Texte,$Cle)
  {
  srand((double)microtime()*1000000);
  $CleDEncryptage = md5(rand(0,32000) );
  $Compteur=0;
  $VariableTemp = "";
  for ($Ctr=0;$Ctr<strlen($Texte);$Ctr++)
    {
    if ($Compteur==strlen($CleDEncryptage))
      $Compteur=0;
    $VariableTemp.= substr($CleDEncryptage,$Compteur,1).(substr($Texte,$Ctr,1) ^ substr($CleDEncryptage,$Compteur,1) );
    $Compteur++;
    }
  return base64_encode(GenerationCle($VariableTemp,$Cle) );
  }

function Decrypte($Texte,$Cle)
  {
  $Texte = GenerationCle(base64_decode($Texte),$Cle);
  $VariableTemp = "";
  for ($Ctr=0;$Ctr<strlen($Texte);$Ctr++)
    {
    $md5 = substr($Texte,$Ctr,1);
    $Ctr++;
    $VariableTemp.= (substr($Texte,$Ctr,1) ^ $md5);
    }
  return $VariableTemp;
  }


//cle de cryptage :

$Cle = "calendrier";
//**********************************************************************


//**************************************************************************************************
//recuperation date a determiner = date de depart + x jours
// parametres :
// $date : date de depart
// $nb_jour_ajout : nombre de jour a ajouter
// $type_donne_recuperation : type de donne  retourner 
//      J-> que le jour, M-> que le mois, A-> que l'anne , 
//      Num_semaine -> numro du jour de la semaine
//     JMA-> jour mois et anne dans le meme format que la date d'entre
// $separateur : caractere sprateur entre jour mois et anne
// $format_date : format de la date fr ou eng
//**************************************************************************************************
 function ajout_jour_date ($date,$nb_jour_ajout,$type_donne_recuperation,$separateur,$format_date) {

 if ( $format_date == "eng" )
    list($annee,$mois,$jour) = explode ( $separateur, $date);
 else
    list($jour,$mois,$annee) = explode ( $separateur, $date);

 $nb_jour_ajouter = $nb_jour_ajout * 3601 * 24 ;
 $nouvelle_date   = mktime(6,0,0,$mois,$jour,$annee) +  $nb_jour_ajouter ;

 if ( $type_donne_recuperation == "J" )
      $nouvelle_date = date("d", $nouvelle_date);
 else if ( $type_donne_recuperation == "M" )
      $nouvelle_date = date("m", $nouvelle_date);
 else if ( $type_donne_recuperation == "A" )
      $nouvelle_date = date("Y", $nouvelle_date);
 else if ( $type_donne_recuperation == "Num_semaine" )
      $nouvelle_date = date("N", $nouvelle_date);
 else  {
   if ( $format_date == "eng" )
       $nouvelle_date = date("Y".$separateur."m".$separateur."d", $nouvelle_date);
   else
       $nouvelle_date = date("d".$separateur."m".$separateur."Y", $nouvelle_date);
 }
 return ($nouvelle_date);

  }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************


//**************************************************************************************************
//recuperation numero de semaine du lundi
// parametres :
// $date : date de depart
// $separateur : caractere sprateur entre jour mois et anne
// $format_date : format de la date fr ou eng
// $sens_recherche : 
//    avant -> rechercher avant la date 
//    apres -> rechercher apres la date
//**************************************************************************************************
 function cherche_num_semaine ($date,$sens,$separateur,$format_date) {
 $lundi_trouve = false ;

 if ( $format_date == "eng" )
    list($annee,$mois,$jour) = explode ( $separateur, $date);
 else
    list($jour,$mois,$annee) = explode ( $separateur, $date);

 $jour_en_seconde = 3600 * 24 ;
 $date_unix   = mktime(6,0,0,$mois,$jour,$annee) ;

 while ( !($lundi_trouve) ) {
     $test_nom_jour =  date("w", $date_unix);
     if ( $test_nom_jour == 1 )
         $lundi_trouve = true ;
     else   {
       if ( $sens == "avant" ) 
         $date_unix   = $date_unix + $jour_en_seconde ;
       else
         $date_unix   = $date_unix - $jour_en_seconde ;
      }

 }
 $numero_semaine = date("W",$date_unix);

 return ($numero_semaine);

 }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************



//**************************************************************************************************
//ajout / supprime 0 dans les dates
// parametres :
// $date : date de depart
// $fonction : fonction  raliser 
//            "Supprime" -> supprime tous les zros inutiles
//            "Ajout"    -> ajout les zros aux chiffres infrieurs  10
// $separateur : caractere sprateur entre jour mois et anne
// $format_date : format de la date fr ou eng
//**************************************************************************************************
 function ajout_supprime_zero ($date,$fonction,$separateur,$format_date) {

 if ( $format_date == "eng" )
    list($annee,$mois,$jour) = explode ( $separateur, $date);
 else
    list($jour,$mois,$annee) = explode ( $separateur, $date);

 if ( $fonction == "Supprime" ) {
    $jour = (int)$jour;
    $mois = (int)$mois;
 }
 else {
    if ( $jour < 10 )
        $jour = "0".(int)$jour;
    if ( $mois < 10 )
        $mois = "0".(int)$mois;
 }
 if ( $format_date == "eng" ) {
    $nouvelle_date = $annee.$separateur.$mois.$separateur.$jour;
 }
 else {
    $nouvelle_date = $jour.$separateur.$mois.$separateur.$annee;
 }

 return ($nouvelle_date);

 }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************


//**************************************************************************************************
//calcul nombre de jours entre 2 dates
// parametres :
// $date_debut : date de depart
// $date_fin : date de fin
// $separateur : caractere sprateur entre jour mois et anne
// $format_date : format de la date fr ou eng
//**************************************************************************************************
 function nb_jour_date ($date_debut,$date_fin,$separateur,$format_date) {

 if ( $format_date == "eng" ) {
    list($annee_debut,$mois_debut,$jour_debut) = explode ( $separateur, $date_debut);
    list($annee_fin,$mois_fin,$jour_fin) = explode ( $separateur, $date_fin);
 }
 else {
    list($jour_debut,$mois_debut,$annee_debut) = explode ( $separateur, $date_debut);
    list($jour_fin,$mois_fin,$annee_fin) = explode ( $separateur, $date_fin);
 }
 $jour_en_seconde = 3600 * 24 ;
 $nb_jour = (int)round (( mktime(6,0,0,$mois_fin,$jour_fin,$annee_fin) - mktime(6,0,0,$mois_debut,$jour_debut,$annee_debut) ) / $jour_en_seconde);

 return ($nb_jour);

 }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************


//**************************************************************************************************
// affiche les messages suite action sur formulaire
//**************************************************************************************************
 function message_info ($message) {

 $afffiche       = false ;
 $bckg_couleur   = "#DBF5A3";
 $border_couleur = "#32CD32";
 $texte_couleur  = "#000000";
 $duree          = 4000;
 $largeur        = 500;
 $hauteur        = 35;
 $opacity        = 0.90;
 $opacity2       = 90;
 $image          = '';
 $texte          = '';

 if ( $message == 'modif_ok') {
     $texte    = 'Modification enregistre !' ;
     $afffiche = true ;
     $image    = '<img src="images/check.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'ajout_ok') {
     $texte    = 'Ajout enregistr !' ;
     $afffiche = true ;
     $image    = '<img src="images/check.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'supprime_ok') {
     $texte    = "Suppression russie !" ;
     $afffiche = true ;
     $image    = '<img src="images/check.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'efface_date_ok') {
     $texte    = 'Les dates ont taient ffaces !' ;
     $afffiche = true ;
     $image    = '<img src="images/check.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'restaure_ok') {
     $texte    = 'Restauration russie !' ;
     $afffiche = true ;
     $image    = '<img src="images/check.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'restaure_calendrier_ok') {
     $texte    = 'Restauration des paramtres du calendrier russie !' ;
     $afffiche = true ;
     $image    = '<img src="images/check.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'mode_demo') {
     $texte    = 'Mode de dmonstration activ!<br>&nbsp;&nbsp;Les fonctionnalites sont limites' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 70;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }
 
 if ( $message == 'modele_ok') {
     $texte    = 'Le nouveau modle a t charg !' ;
     $afffiche = true ;
     $image    = '<img src="images/check.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_execution') {
     $texte    = 'Erreur d\'xecution ! veuillez recommencer' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $opacity        = 1;
     $opacity2       = 100; 
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_langue') {
     $texte    = 'Le symbole ou le nom de la langue existe dj!' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_connexion') {
     $texte    = 'Erreur de connexion!<br>L\'identifiant et/ou le mot de passe sont incorrects!<br>(attention aux minuscules ou majuscules)' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_sessions') {
     $texte    = 'Les sessions ne sont pas actives sur votre serveur<br>ou elles ont ts perdues!' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 50;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_connecte_sql') {
     $texte    = 'Impossible de se connecter au serveur sql!<br>Veuillez vrifier les paramtres de connexion.<br>- adresse serveur - nom utilisateur - mot de passe -' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_connecte_base') {
     $texte    = 'Impossible de se connecter  la base de donnes !<br>Veuillez vrifier les paramtres de connexion.<br>- nom de votre base -' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_fichier_locataire') {
     $texte    = 'Le fichier locataire semble tre incorrect!<br> <a href="base.php" >Cliquez ici</a> pour restaurer le fichier<br>' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_fichier_com_locataire') {
     $texte    = 'Le fichier commentaires locataire semble tre incorrect!<br> <a href="base.php" >Cliquez ici</a> pour restaurer le fichier<br>' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_fichier_logement') {
     $texte    = 'Le fichier liste location semble tre incorrect!<br> <a href="base.php" >Cliquez ici</a> pour restaurer le fichier<br>' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_fichier_couleur') {
     $texte    = 'Le fichier couleur semble tre incorrect!<br> <a href="base.php" >Cliquez ici</a> pour restaurer le fichier<br>' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_fichier_parametres') {
     $texte    = 'Le fichier paramtres du calendrier semble tre incorrect!<br> <a href="base.php" >Cliquez ici</a> pour restaurer le fichier<br>' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $message == 'erreur_fichier_dates') {
     $texte    = 'Les fichiers contenant les dates semblent tre incorrect!<br> <a href="restaure_fichier_date.php" >Cliquez ici</a> pour restaurer les fichiers<br>' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 90;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }
 
 if ( $message == 'erreur_upload_zip') {
     $texte    = 'La restauration n\'as pas t ralise!<br>Le fichier  transfrer doit s\'appeller sauvegarde.zip (Max = 8MB )<br>Si le problme persiste, transfrer le fichier sauvegarde via FTP, rpertoire admin/fichier_calendrier<br>puis cliquer pour faire une restauration  partir de la sauvegarde serveur' ;
     $afffiche = true ;
     $bckg_couleur   = "#FF6262";
     $border_couleur = "#FF0000";
     $texte_couleur  = "#FFFFFF";
     $duree          = 10000;
     $hauteur        = 120;
     $largeur        = 600;
     $opacity        = 1;
     $opacity2       = 100;
     $image    = '<img src="images/alerte.png" id="Image15" border="0" style="width:20px;">';
 }

 if ( $afffiche )
    echo '<div id="info" style="position:absolute;overflow:visible;background-color:',$bckg_couleur,';border:1px ',$border_couleur,' solid;visibility:hidden;opacity:',$opacity,';-moz-opacity:',$opacity,';-khtml-opacity:',$opacity,';filter:alpha(opacity=',$opacity2,');width:',$largeur,'px;height:',$hauteur,'px;z-index:17" title="message info">
          <div id="wb_Text2" style="margin:0;padding:0;position:absolute;left:10px;top:5px;text-align:center;z-index:12;">
          ',$image,'&nbsp;<font style="font-size:16px" color="',$texte_couleur,'" face="Arial"><b>',$texte,'</b></font>
          </div>
          </div>

          <script type="text/javascript">
          document.getElementById(\'info\').style.visibility = \'visible\' ;
          setTimeout("document.getElementById(\'info\').style.visibility = \'hidden\' ;",',$duree,');
          </SCRIPT>

          ';


 }

//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************


//**************************************************************************************************
//ajout / supprime 0 dans les dates
// parametres :
// $id      : nom et id de la liste
// $largeur : largeur en px de la liste
// $tableau : tableau a transformer en liste
// $tableau_2 : second tableau pour les prenoms
// $zero_exclus   : exclure de la liste l'index zro du tableau
// $valeur_defaut : valeur a preselectionne dans la liste
// $afficher_groupe : si true affiche des groupes par la premiere lettre
// $formulaire : id du formulaire a soumettre en cas de selection
//**************************************************************************************************
 function liste_box ($id,$largeur,$tableau,$tableau2,$zero_exclus,$valeur_defaut,$afficher_groupe,$formulaire) {
       $destination_formulaire = ( $formulaire <> '') ? 'onchange="document.'.$formulaire.'.submit();return false;"' : '';
       echo '<select name="',$id,'" size="1" id="',$id,'" style="width:',$largeur,'px;border-width:1px;font-family:Courier New;font-size:16px;" ',$destination_formulaire,'>';
       if ( !$zero_exclus && isset($tableau[0]) )
           echo '<option selected value="0" >',stripslashes($tableau[0]),'</option>' ;
       $memoire = '';
       $cle_fichier ='';
       $memoire_tab_tri = '';
       $nb_result = count ($tableau);
       if ( $nb_result > 0 ) {
        asort($tableau);  //tri alphabtique ********
        foreach ($tableau as $cle_fichier => $val_tab)  {

            $premiere_lettre = ( !is_numeric($cle_fichier) || ( is_numeric($cle_fichier) && $cle_fichier <> 0) ) ? ucfirst(substr(stripslashes($val_tab), 0, 1)): '';
            if ( $premiere_lettre <> $memoire_tab_tri && $afficher_groupe)
                echo '<optgroup label="',ucfirst($premiere_lettre),'" style="background-color:#CEDCF2;">';
            if ( ($cle_fichier <> 0 || !is_numeric($cle_fichier) ) && $val_tab <> '') { // test si contenu diffrent de "tous"**********
               $val_tableau_2 = ( isset($tableau2[$cle_fichier]) ) ? $tableau2[$cle_fichier] : ''; 
               if ( $valeur_defaut == $cle_fichier )
                echo '<option selected value="',$cle_fichier,'" style="background-color:#FFFFFF;">',$val_tab,' ',$val_tableau_2,'</option>' ;
               else
                echo '<option value="',$cle_fichier,'" style="background-color:#FFFFFF;">',$val_tab,' ',$val_tableau_2,'</option>' ;
               $memoire_tab_tri = $premiere_lettre;
             }
           }
        }
        echo '</select>';

 }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************


//**************************************************************************************************
//convertit les br vers \n
// parametres :
// $string : chaine  convertir
//**************************************************************************************************
function br2nl($text)
{
    return  preg_replace('/<br\\s*?\/??>/i', '', $text);
}
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************

//**************************************************************************************************
//convertit les caractres spciaux dans les fichiers
// parametres :
// $string : chaine  convertir
//**************************************************************************************************
function suppr_char_spec($texte)
{
    return  preg_replace("(\r\n|\n|\r)",' ',$texte);
}
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************

//**************************************************************************************************
//Tlchargement d'un fichier
// parametres :
// $fichier_a_telecharger : nom du fichier
// $chemin                : chemin relatif jusqu'au rpertoire du fichier
//**************************************************************************************************
function telecharge ($fichier_a_telecharger,$chemin) {
switch(strrchr(basename($fichier_a_telecharger), ".")) {

case ".gz": $type = "application/x-gzip"; break;
case ".tgz": $type = "application/x-gzip"; break;
case ".zip": $type = "application/zip"; break;
case ".pdf": $type = "application/pdf"; break;
case ".png": $type = "image/png"; break;
case ".gif": $type = "image/gif"; break;
case ".jpg": $type = "image/jpeg"; break;
case ".txt": $type = "text/plain"; break;
case ".htm": $type = "text/html"; break;
case ".html": $type = "text/html"; break;
default: $type = "application/octet-stream"; break;

}

header("Content-disposition: attachment; filename=$fichier_a_telecharger");
header("Content-Type: application/force-download");
header("Content-Transfer-Encoding: $type\n"); // Surtout ne pas enlever le \n
header("Content-Length: ".filesize($chemin . $fichier_a_telecharger));
header("Pragma: no-cache");
header("Cache-Control: must-revalidate, post-check=0, pre-check=0, public");
header("Expires: 0");
readfile($chemin . $fichier_a_telecharger);
}
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************

//**************************************************************************************************
// recriture url des images pour les modeles
// parametres :
// $url             : url absolu du fichier a copier
// $adresse_script  : chemin absolu installation du script
// $chemin_modele   : chemin relatif vers le rpertoire du modele
//**************************************************************************************************

function image_modele ($url,$adresse_script,$chemin_modele) {
  if ( $url <> '' ) {
   $nom_fichier    = basename($url);
   // nouvelle adresse de l'image ****************
   $adresse = $chemin_modele."/".$nom_fichier ;
   //calcul des chemins relatif ******************
   $chemin_script = parse_url($adresse_script, PHP_URL_PATH);
   $chemin_image  = parse_url($url, PHP_URL_PATH);
   
   $script_nb_sl = substr_count($chemin_script, '/');;
   $image_nb_sl  = substr_count($chemin_image, '/');;

   $back = '';

   for ( $i = 1; $i <= $script_nb_sl; $i++) {
       $back .= "../";
   }

   $url_relatif_image = $back.substr_replace($chemin_image, '', 0, 1);
   // copy de l'image dans le rpertoire du modele******
   @copy($url_relatif_image,$adresse);
   @chmod ($adresse,0644);

   //$adresse = $adresse_script."admin/".$adresse;
  }
  else
    $adresse = '' ;
   return ($adresse);
}
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************

//**************************************************************************************************
// calcul date suprieur / infrieur
// parametres :
// $date_debut       : date de depart
// $date_fin         : date de fin
// $type_recherche ->
//   superieur       : retourne true si la date de fin est superieur  la date de fin
//   inferieur       : retourne true si la date de fin est inferieur  la date de fin
//   inferieur_egale : retourne true si la date de fin est inferieur ou gale  la date de fin
//   egale           : retourne true si la date de fin est gale  la date de fin
//   superieur_egale : retourne true si la date de fin est superieur ou gale  la date de fin
// $separateur       : caractere sprateur entre jour mois et anne
// $format_date     : format de la date fr ou eng
//**************************************************************************************************
 function comparaison_date ($date_debut,$date_fin,$type_recherche,$separateur,$format_date) {
 $resultat = false ;

 if ( $format_date == "eng" ) {
    list($annee_debut,$mois_debut,$jour_debut) = explode ( $separateur, $date_debut);
    list($annee_fin,$mois_fin,$jour_fin) = explode ( $separateur, $date_fin);
 }
 else {
    list($jour_debut,$mois_debut,$annee_debut) = explode ( $separateur, $date_debut);
    list($jour_fin,$mois_fin,$annee_fin) = explode ( $separateur, $date_fin);
 }

 $jour_en_seconde = 3600 * 24 ;
 $nb_jour = (int)round (( mktime(6,0,0,$mois_fin,$jour_fin,$annee_fin) - mktime(6,0,0,$mois_debut,$jour_debut,$annee_debut) ) / $jour_en_seconde);

 if ( $type_recherche == 'egale' && $nb_jour == 0 )
    $resultat = true ;
 if ( $type_recherche == 'superieur' && $nb_jour > 0 )
    $resultat = true ;
 if ( $type_recherche == 'superieur_egale' &&  ( $nb_jour > 0 ||  $nb_jour == 0 ) )
    $resultat = true ;
 if ( $type_recherche == 'inferieur' && $nb_jour < 0  )
    $resultat = true ;
 if ( $type_recherche == 'inferieur_egale' && ( $nb_jour < 0 ||  $nb_jour == 0 ) )
    $resultat = true ;

 return ($resultat);

 }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************

//*******************************************************************************************
// suppression des accents
//*******************************************************************************************

function suppr_accents($chaine) {
   $accents = array("","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","'");
   $sans = array("A","A","A","A","A","A","C","E","E","E","E","I","I","I","I","O","O","O","O","O","U","U","U","U","Y","a","a","a","a","a","a","c","e","e","e","e","i","i","i","i","o","o","o","o","o","o","u","u","u","u","y","y","");
   return str_replace($accents, $sans, $chaine);
}

//**************************************************************************************************
// module recherche de disponibilits par mi toutes les locations entre 2 dates choisies
// la fonction retourne un tableau avec la liste des locations disponibles
// parametres :
// $chemin_admin     : chemin relatif depuis l'endroit d'appel de la fonction jusqu'au rpertoire admin du calendrier
// $date_debut       : date de debut de recherche format JJ/MM/AAAA
// $date_fin         : date de fin de recherche format JJ/MM/AAAA
// $capacite         : capacit minimale de la location en nombre de personnes
//                     si = 0 alors ne tient pas compte de la capacit
// $affiche_erreurs  : affiche les erreurs eventuelles ( format date, date fin anterieur date debut)
//**************************************************************************************************

 function recherche_dispo($chemin_admin,$date_debut,$date_fin,$capacite,$affiche_erreurs ) {

 //inclusion du fichier connexion ***************************
  require_once ($chemin_admin."genere/connexion.php");
 //inclusion liste des couleurs ****************************
  require_once ($chemin_admin."fichier_calendrier/calendrier_liste_couleur.php");
 //inclusion liste des locations ****************************
  require_once ($chemin_admin."fichier_calendrier/calendrier_liste_logement.php");

   $erreur_compare_date = false;
   // test format des dates ********************************
   $test_post_debut = test_date_fr ($date_debut);
   $test_post_fin = test_date_fr ($date_fin);

   if ( $test_post_debut <> 0 && $affiche_erreurs )
       echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> *** Le format de la date de dbut n\'est pas conforme, il doit tre JJ/MM/AAAAA</font><br><br>';
   if ( $test_post_fin <> 0 && $affiche_erreurs )
       echo '<font style="font-size:16px;" color="#FF0000" face="Arial">*** Le format de la date de fin n\'est pas conforme, il doit tre JJ/MM/AAAAA</font><br><br>';
   if ( $test_post_debut == 0 && $test_post_fin == 0 && comparaison_date ($date_fin,$date_debut,"superieur","/","fr") )  {
       $erreur_compare_date = true;
       if ( $affiche_erreurs)
           echo '<font style="font-size:16px;" color="#FF0000" face="Arial">*** La date de fin doit tre postrieur  la date de dbut</font><br><br>';
   }

   // conversion des dates au format anglais ***************
   $date_debut_eng   = ajout_supprime_zero (date_fr_eng($date_debut,"/","-"),"Ajout","-","eng");
   $date_fin_eng     = ajout_supprime_zero (date_fr_eng($date_fin,"/","-"),"Ajout","-","eng");
   
   //**************************************************************************
   // recherche des disponibilits *************************
   //**************************************************************************

   if ( $test_post_debut == 0 && $test_post_fin == 0 && !$erreur_compare_date ) {

      //initialisation tableau des logements disponibles **********************
      $tableau_logement_dispo = $nom_logement ; // hypothese de dpart, tous les locations sont disponibles
      unset ($tableau_logement_dispo[0]);  // suppression logement tous *******

      //***********************************************************************
      // fonctionnement avec base de donnes
      //***********************************************************************

      if ( AVEC_BDD ) {
         //connection a la base de donnees*******************************************************************
         $connect = @mysql_connect(Decrypte(hote_cal,"calendrier"), Decrypte(user_cal,"calendrier"), Decrypte(password_cal,"calendrier"));
         if (!$connect )
           echo '<font style="font-size:16px" color="#FF0000" face="Arial"><b>** Erreur de connexion au serveur sql **</b><br></font>' ;
         else {
         // on choisit la bonne base
         $connect_base = @mysql_select_db(Decrypte(base_cal,"calendrier"), $connect) ;
         if (!$connect_base )
           echo '<font style="font-size:16px" color="#FF0000" face="Arial"><b>** Erreur de connexion  la base sql **</b><br></font>' ;
         else {
            //recherche des jours reservs dans le mois en cours*********************************************
            $valeur_select = "SELECT * FROM ".Decrypte(nom_table_cal,"calendrier")." WHERE date_reservation >= '$date_debut_eng' AND date_reservation <= '$date_fin_eng' order by date_reservation, id ";
            $requete = @mysql_query ($valeur_select);
            while ( $data = mysql_fetch_object($requete) ) {
               if ( !$date_couleur_disponible[$data->couleur_texte] ) // la couleur n'est pas une couleur dispo
                   unset ($tableau_logement_dispo[$data->id_logement]); //efface ce logement ***
            }// fin donnes de la bse de donnes ***

         }// fin select base ****

        } // fin connect sql ****

       } // fin avec bdd ***

      //***********************************************************************
      // fonctionnement sans base de donnes
      //***********************************************************************

       elseif ( !AVEC_BDD ) {
         if ( isset ($nom_logement) ) {
         foreach ($nom_logement as $cle => $libelle_logement ) {
         //recupration des dates pour le logement en cours de traitement *********
         unset($tableau_reservation); // rinitialisation des variables tableau ***
         $chemin_fichier_logement = $chemin_admin."fichier_calendrier/dates_sans_bdd/".$cle."_calendrier.php";
         if ( file_exists($chemin_fichier_logement)) {
              include($chemin_fichier_logement);
         if ( isset($tableau_reservation[$cle]) && $cle <> 0) {
           foreach ($tableau_reservation[$cle] as $date_index => $val_reservation ) {
             // contenu des reservations du logement ***************************
             list($couleur_temp,$couleur_texte_temp,$tri_locataire_temp,$tarif_temp,$commentaire_temp ) = explode('%&%',$tableau_reservation[$cle][$date_index]);

             if ( !$date_couleur_disponible[$couleur_texte_temp] && comparaison_date ($date_debut_eng,$date_index,"superieur_egale","-","eng") && comparaison_date ($date_fin_eng,$date_index,"inferieur_egale","-","eng") ) // la couleur n'est pas une couleur dispo
                unset ($tableau_logement_dispo[$cle]); //efface ce logement ***

           }// fin pour toutes les reservations ******************************

         } // fin listage des rservations pour le logement ******************
           
         }// fin si fichier du logement existe *******************************
           
         }// fin boucle pour tous les logements ******************************

         }// fin test si des logements existent ******************************

       } // fin traitement sans base de donnes ******************************

   // le tableau php tableau_logement_dispo contient la liste des logements disponibles
   //print_r($tableau_logement_dispo);
   //echo "<br>";
   } // fin test ok pour recherche dispo ***

 // controle de la capacit maximale d'accueil , si le parametre $capacit de la fonction est suprieur  0
 // si  $capacit = 0 , alors on ne doit pas tenir compte de la capacit dans les recherches de dispo
 if ( isset ($tableau_logement_dispo) && (int)$capacite >= 0 ) {
      foreach ($tableau_logement_dispo as $cle => $libelle_logement ) {
         if ( $capacite_logement[$cle] < (int)$capacite  ) //le logement est disponible mais sa capacit est trop faible
            unset ($tableau_logement_dispo[$cle]); //efface ce logement ***
      }
 }

 if ( isset($tableau_logement_dispo) )
      return ($tableau_logement_dispo);

 }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************

//**************************************************************************************************
// module insertion date et locataire depuis formulaire visiteur
// la fonction retourne un tableau avec la liste des locations disponibles
// parametres :
// $chemin_admin     : chemin relatif depuis l'endroit d'appel de la fonction jusqu'au rpertoire admin du calendrier
// $id_logement_marquer: numro id de la location a marquer
// $date_debut       : date de debut de recherche format JJ/MM/AAAA
// $date_fin         : date de fin de recherche format JJ/MM/AAAA
// $tableau_locataire: nom du locataire tableau contenant les informations du locataires
// ajout_locataire   : si le locataire n'existe pas , il sera rajout
// couleur           : numro id de la couleur du marqueur pour la priode a marquer
// nb_max_jour       : nombre maximum de jours successifs pouvant tre marqus
// ctrl_date_existe  : si true alors, si dans l'intervalle date debut/date fin , il y a au moins une date de couleur dites
//                     non disponible alors les dates indiques ne sont pas enregistres dans le calendrier
// $affiche_erreurs  : affiche les erreurs eventuelles ( format date, date fin anterieur date debut)
// La fonction retourne TRUE si les dates ont taient marques
//**************************************************************************************************
 function insertion_date($chemin_admin,$id_logement_marquer,$date_debut,$date_fin,$tableau_locataire,$ajout_locataire,$couleur,$nb_max_jour,$ctrl_date_existe,$affiche_erreurs ) {
  //intialisation de variables ******************************
  $creation_reussi_date      = false;
  $creation_reussi_locataire = false;
  $couleur_indisponible_existe = false ;
 //inclusion du fichier connexion ***************************
  require ($chemin_admin."genere/connexion.php");
 //inclusion liste des couleurs ****************************
  require ($chemin_admin."fichier_calendrier/calendrier_liste_couleur.php");
 //inclusion liste des locations ****************************
  require ($chemin_admin."fichier_calendrier/calendrier_liste_logement.php");
 //inclusion liste des locations ****************************
  require ($chemin_admin."fichier_calendrier/calendrier_liste_locataire.php");
 //inclusion liste des locations ****************************
  require ($chemin_admin."fichier_calendrier/parametres_calendrier.php");

  //***************************************************************
  //traitement du locataire ***************************************
  //***************************************************************
  
  if ( $ajout_locataire && !MODE_DEMO ) {
  //controle si le locataire existe deja **************************
  $locataire_existe = false;
  $num_pointeur_max = 0;
  $nom_minuscule    = strtolower(suppr_accents($tableau_locataire[0]));
  $prenom_minuscule = strtolower(suppr_accents($tableau_locataire[1]));
  foreach ( $nom_locataire as $cle => $val_nom_locataire ) {
    if ( $cle <> 0 && $ajout_locataire) {
      $nom_minuscule_fichier    = strtolower(suppr_accents($nom_locataire[$cle]));
      $prenom_minuscule_fichier = strtolower(suppr_accents($prenom_locataire[$cle]));
      //controle si le locataire est deja dans la base de donnes ***************
      if ($nom_minuscule_fichier == $nom_minuscule && $prenom_minuscule_fichier == $prenom_minuscule )  {
        $locataire_existe = true ;
        $creation_reussi_locataire = true ;
        $num_pointeur_max = $cle;
      }
     }
  }// fin foreach locataire
  }
  
  // si le locataire n'existe pas dans le fichier il sera ajout ****
  if ( !$locataire_existe && $ajout_locataire && $tableau_locataire[0] <> '' && !MODE_DEMO) {
      $fichier_libre  = false;
      $fin_tableau_locataire = false ;
      $chemin_fichier = $chemin_admin."fichier_calendrier/calendrier_liste_locataire.php";
      $chemin_fichier_sauvegarde = $chemin_admin."fichier_calendrier/sauvegarde_calendrier_liste_locataire.php";

      while (!isset($fin_tableau_locataire)  || !$fin_tableau_locataire) {  // controle que le fichier est disponible
        include ($chemin_fichier);
        if ( isset($fin_tableau_locataire)  && $fin_tableau_locataire ) {
        //sauvegarde ancien fichier*********************************
        @copy($chemin_fichier,$chemin_fichier_sauvegarde);
        $file= @fopen($chemin_fichier, "w");
        $fichier_libre = true;
        $fonction = 'Ajout_formulaire';
        }
       }

      // mise a jour du fichier locataire **************************************
      define ("AUTOR_FCT_GEN_LOCATAIRE", true);
      if ( $fichier_libre )
         //chemin vers le fichier de cration liste des locataires/logements**********************************************************
         require($chemin_admin."genere/genere_listes_locataire.php");
      $creation_reussi_locataire = $creation_reussi ;
  }
    else
      $creation_reussi_locataire = true ;   // il ne faut aps ajouter le locataire***

  //*******************************************************************************
  //gestion des dates *************************************************************
  //*******************************************************************************

  if ( $avec_diagonale_cellule )
       $date_fin = jour_precedent ($date_fin,"/","fr");

   $test_post_debut = test_date_fr ($date_debut);
   $test_post_fin = test_date_fr ($date_fin);

  if (  $test_post_debut==0 && $test_post_fin==0 )
    //test pour eviter de marquer un nombre de jour reserv trop important > nb_max_jour jours
    $compare_date = nb_jour_date ($date_debut,$date_fin,"/","fr");
  elseif ( $affiche_erreurs)
    echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> *** Le format des dates ne sont pas conforme, ils doivent tre JJ/MM/AAAAA</font><br><br>';
  // controle nombre maximum de jours a marquer ******************
  if ( $compare_date > $nb_max_jour && $affiche_erreurs )
    echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> Les dates n\'ont pas pu tre enregistre car l\'intervalle est trop grand !</font><br><br> ';
  if ( $compare_date < 0 && $affiche_erreurs )
    echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> Les dates n\'ont pas pu tre enregistre car la date de fin est antrieure  la date de dbut!</font><br><br> ';

  if (  $test_post_debut==0 && $test_post_fin==0 && $compare_date >= 0  && $compare_date <= $nb_max_jour && !MODE_DEMO) {

      $date_debut_eng   = ajout_supprime_zero (date_fr_eng($date_debut,"/","-"),"Ajout","-","eng");
      $date_fin_eng     = ajout_supprime_zero (date_fr_eng($date_fin,"/","-"),"Ajout","-","eng");

      $tarif = str_replace(",",".",$tarif_logement[$id_logement_marquer]);  // transformation des virgules en . pour les chiffres

      // initialisation de variables ******************************************
      unset($tableau_requete);  // initialisation du tableau des logements a marqus***

      //***********************************************************************
      // liste des locations  marquer *****************************************
      //***********************************************************************
      // attention marquage tous est forc a false !!! ************************
      if ( isset($marquer_tous) && $marquer_tous == 'oui' && TOUJOURS_FALSE ) {// si marquage de toutes les locations
          $tableau_requete = $nom_logement ;   // tableau des locations = toutes les locations
          unset($tableau_requete[0]); // suppression index logement tous ******
          }
      else
          $tableau_requete[$id_logement_marquer] = $nom_logement[$id_logement_marquer];  // tableau des locations = toutes les locations

      //***********************************************************************
      // fonctionnement avec base de donnes
      //***********************************************************************
      
      if ( AVEC_BDD ) {
      //connection a la base de donnees*******************************************************************
      $connect = @mysql_connect(Decrypte(hote_cal,"calendrier"), Decrypte(user_cal,"calendrier"), Decrypte(password_cal,"calendrier")) ;
      if ( !$connect && $affiche_erreurs )
         echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> *** Erreur de connexion au serveur sql<br><br>';
      $connect_base = @mysql_select_db(Decrypte(base_cal,"calendrier"), $connect);
      if ( !$connect_base && $affiche_erreurs )
         echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> *** Erreur de connexion  la base sql<br><br>';
      // boucle de marquage des dates pour le ou les locations selectionnes 1 par 1 ****
      foreach ( $tableau_requete as $cle => $nom_logement_requete ) {

      //initialisation liste requete*****************************************
      $date_boucle      = $date_debut_eng ;
      $tri_logement_req = ", '".$cle."'" ;
      $tri_logement_req2 = " and id_logement = '".$cle."'" ;
      $tri_locataire2   = ", '".$num_pointeur_max."'";
      $liste_couleur_req = '';
      $liste_query = '';
      $compare_date = nb_jour_date ($date_debut,$date_fin,"/","fr");
      $commentaire = ( isset($tableau_locataire[8]) ) ?  addslashes(nl2br($tableau_locataire[8])) : '' ;

      //***********************************************************************************************
      // controle si date de couleur indisponible existe dans le calendrier pour la priode voulue ****
      //***********************************************************************************************
      
      //liste des couleurs dites dates indisponibles **********************
      if ( isset($date_couleur_disponible) && $ctrl_date_existe ) {
          foreach ($date_couleur_disponible as $cle => $disponible ) {
              if ( !$disponible ) {
                if ( $liste_couleur_req == '' ) 
                     $liste_couleur_req .= ' and ( ';
                else
                     $liste_couleur_req .= ' OR ';
                 $liste_couleur_req .= " couleur_texte = '$cle' ";
              }
          }
         if ( $liste_couleur_req <> '' )
              $liste_couleur_req .= ' ) ';
      }

      // recherche si des dates avec couleurs indisponible sont deja marques dans la base *************
      $req_ctrl = "SELECT * from ".Decrypte(nom_table_cal,"calendrier")." where date_reservation >= '$date_debut_eng' and date_reservation <= '$date_fin_eng' $tri_logement_req2 $liste_couleur_req" ;
      $requete = @mysql_query($req_ctrl );
      $nj_jour = mysql_num_rows($requete);

      if ( $nj_jour == 0 || !$ctrl_date_existe ) {  // marquage des jours si le controle date est hors service ou si controle date ok

      //effacement des dates eventuellement dj marques si la couleur en cours n'est pas une couleur invisible******
      $req_sql = "delete from ".Decrypte(nom_table_cal,"calendrier")." where date_reservation >= '$date_debut_eng' and date_reservation <= '$date_fin_eng' $tri_logement_req2 ";
      if ( !$couleur_invisible[$couleur] )
            @mysql_query($req_sql);

      //ajout dans la liste du premier jour **************************************************************************
      $liste_query .= "(NULL, '".$date_boucle."', '".$couleur_reserve[$couleur]."', '".$couleur."' $tri_logement_req  $tri_locataire2 , '".$tarif."', '".$commentaire."')";

      while ( $compare_date > 0 ) {
      $date_boucle  =  ajout_jour_date ($date_boucle,1,"JMA","-","eng");
      if ( $liste_query <> '')   // controle si premiere insertion
        $liste_query .= ' ,';
      // on ajoute les marqueurs dans la semaine*******************************
      $liste_query .= "(NULL, '".$date_boucle."', '".$couleur_reserve[$couleur]."', '".$couleur."' $tri_logement_req  $tri_locataire2 , '".$tarif."', '".$commentaire."')";
      $compare_date = nb_jour_date ($date_boucle,$date_fin_eng,"-","eng");
      }
     $liste_query .= " ;";

     $query = "INSERT INTO `".Decrypte(nom_table_cal,"calendrier")."` (`id`, `date_reservation`, `couleur`, `couleur_texte`, `id_logement`, `id_locataire`, `tarif`, `commentaires`) VALUES
              $liste_query";
     $creation_reussi_date = @mysql_query($query)  ;
         }  // fin boucle marquage si controle date ok *************************
            //******************************************************************
      else {
          if ( $affiche_erreurs )
          echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> Les dates n\'ont pas pu tre enregistre car il y a dj des jours indisponibles dans cette periode! </font><br><br>';
          $creation_reussi_date = true ; // pas de prise en compte de la requete mais pas d'erreur de fonctionnment
         }
       }  // fin boucle foreach insertion des dates dans la base de donnes*****
          //********************************************************************
     }    // fin fonctionnement avec base de donnes ***************************
          //********************************************************************


      //***********************************************************************
      // fonctionnement sans base de donnes  - ajout
      //***********************************************************************
      
      else {
      // boucle de marquage des dates pour le ou les locations selectionnes 1 par 1 ****
      foreach ( $tableau_requete as $cle => $nom_logement_requete ) {
      //recupration des dates pour le logement en cours de traitement *********
      unset($tableau_reservation); // rinitialisation des variables tableau ***
      require($chemin_admin."fichier_calendrier/dates_sans_bdd/".$cle."_calendrier.php");
      
      //initialisation liste requete*****************************************
      $nb_jour_a_marquer = nb_jour_date ($date_debut,$date_fin,"/","fr") + 1;
      $commentaire = ( isset($tableau_locataire[8]) ) ?  guillet_var ($tableau_locataire[8]) : '' ;

      //***********************************************************************************************
      // controle si date de couleur indisponible existe dans le calendrier pour la priode voulue ****
      //***********************************************************************************************
      
      $date_boucle      = $date_debut_eng ;

      for ( $i = 1; $i <= $nb_jour_a_marquer; $i++ ) {
          if ( isset($tableau_reservation[$cle][$date_boucle]) ) {
               list($couleur_temp,$couleur_texte_temp,$tri_locataire_temp,$tarif_temp,$commentaire_temp ) = explode('%&%',$tableau_reservation[$cle][$date_boucle]);
               if ( !$date_couleur_disponible[$couleur_texte_temp] )
                     $couleur_indisponible_existe = true ;
          }
          $date_boucle = ajout_jour_date ($date_boucle,1,"JMA","-","eng") ;
     }

     if ( !$couleur_indisponible_existe || !$ctrl_date_existe ) { // s'il n'y pas de couleur indisponible ****
      $date_boucle      = $date_debut_eng ;

      //controle si le fichier est disponible pour criture *****************
      $fichier_libre = false;
      $chemin_fichier = $chemin_admin.'fichier_calendrier/dates_sans_bdd/'.$cle.'_calendrier.php';
      $chemin_fichier_sauvegarde = $chemin_admin.'fichier_calendrier/dates_sans_bdd/'.$cle.'_sauvegarde_calendrier.php';
      $pointeur_variable_fin_fichier_ok = 'fin_tableau_reservation_'.$cle;
      unset($$pointeur_variable_fin_fichier_ok);

      while (!isset($$pointeur_variable_fin_fichier_ok)  || !$$pointeur_variable_fin_fichier_ok) {
        include ($chemin_fichier);
        if ( isset($$pointeur_variable_fin_fichier_ok)  && $$pointeur_variable_fin_fichier_ok ) {
        //sauvegarde ancien fichier*********************************
        @copy($chemin_fichier,$chemin_fichier_sauvegarde);
        $file= @fopen($chemin_fichier, "w");
        $fichier_libre = true;
        }
      }

      if ( !$couleur_invisible[$couleur] ) {
        //effacement des dates eventuellement dj marques ********************
        for ( $i = 1; $i <= $nb_jour_a_marquer; $i++ ) {
          if ( isset($tableau_reservation[$cle][$date_boucle]) ) {
               unset($tableau_reservation[$cle][$date_boucle]);
          }
           $date_boucle = ajout_jour_date ($date_boucle,1,"JMA","-","eng") ;
          }
       }// fon ctrl couleur invisible ***
       $date_boucle      =  $date_debut_eng ;

       for ( $i = 1; $i <= $nb_jour_a_marquer; $i++ ) {
         $tableau_reservation[$cle][$date_boucle] = $couleur_reserve[$couleur]."%&%".$couleur."%&%".$num_pointeur_max."%&%".$tarif."%&%".guillet_var ($commentaire);
         $date_boucle = ajout_jour_date ($date_boucle,1,"JMA","-","eng") ;
       }
       // mise a jour du fichier *********************************************
       $vecteur_index_logement = $cle;
       $chemin_vers_fichier = $chemin_admin;
       define ("AUTOR_FCT_GEN_CALENDRIER", true);
       if ( $fichier_libre)
           require($chemin_admin."genere/genere_tableau_calendrier.php");
       $creation_reussi_date = ( isset($creation_reussi) ) ? $creation_reussi: false ;
       
       }  // fin traitement controle si couleur indisponible existe dans la priode
          //********************************************************************
      
       else {
          if ( $affiche_erreurs )
           echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> Les dates n\'ont pas pu tre enregistre car il y a dj des jours indisponibles dans cette periode!</font><br><br> ';
          $creation_reussi_date = false ; // pas de prise en compte de la requete mais pas d'erreur de fonctionnment
          }
        } // fin boucle foreach insertion des dates sans la base de donnes*****
          //********************************************************************

     }    // fin fonctionnement avec base de donnes ***************************
          //********************************************************************

     if ( !$creation_reussi_date && $affiche_erreurs )
         echo  "Erreur d'execution pour l'insertion des dates<br><br><br>";
     if ( !$creation_reussi_locataire && $affiche_erreurs )
         echo  "Erreur d'execution pour l'insertion du locataire<br><br><br>";

    }
    $creation_reussi = ( ($creation_reussi_date && $creation_reussi_locataire) || MODE_DEMO) ? true : false ;
    if ( MODE_DEMO )
      echo '<font style="font-size:16px;" color="#FF0000" face="Arial"> Mode de dmonstration active, fonctionnalites limitts</font><br><br> ';

return ($creation_reussi);

 }
//**************************************************************************************************
//**************************************************************************************************
//**************************************************************************************************

//**************************************************************************************************
// compression zip de rpertoire
// la fonction comprime le rpertoire donne en parametres
// parametres :
// $path      : chemin relatif jusqu'au rpertoire  compresser
//**************************************************************************************************

function zipDir($path,&$zip)
{
   
   if (!is_dir($path)) return;
   
   if (!($dh = @opendir($path))) {
      echo("<b>ERREUR: Une erreur s'est produite sur ".$path."</b><br />");
      return;
   }
   while ($file = readdir($dh)) {
     
      if ($file == "." || $file == ".." || $file == "sauvegarde.zip" ) continue; // Throw the . and .. folders
      if (is_dir($path."/".$file)) { // Recursive call
         zipDir($path."/".$file,$zip,$i);   
      } elseif (is_file($path."/".$file)) { // If this is a file then add to the zip file
         
         $zip->addFile(file_get_contents($path."/".$file),$path."/".$file);
         //echo('fichier '.$path.'/'.$file.' ajout<br>');
      }
      }
}


?>